// Top-level application function of an Adaptive
// Application (AA) which uses the Deterministic Client
int AppCode(void)
{
    ActivationReturnType dccType;   // Deterministic Client
    // Cycle (DCC) type

    while (1) { // endless loop
        dccType = DeterministicClient.WaitForNextActivation();
        // each execution of the code below is one "Cycle"
        switch (dccType) {
        case kRegisterServices:
            // call handler registering services here
            break;
        case kServiceDiscovery:
            // call service discovery handler here
            break;
        case kInit:
            // call init handler here
            break;
        case kRun:
            // call cyclic App handler here
             break;
        case kTerminate:
            return 0; // terminate with success
        default: // invalid return value
            return 1; // terminate with error
        }
    }
}